#include "common.ch"
#include "appevent.ch"
#include "xbp.ch"
#include "xbzlib.ch"

proc dbesys(); return

Procedure Main()
   local nSecs, nSecs1

   wait 'Begin...XbpBitmap2()'
   nSecs1 := Seconds()
   ? Bmp2Png256(TRUE)
   nSecs1 := Seconds() - nSecs1
   wait '...Finished: '+LTrim(Str(nSecs1))+' seconds'
   return

Function MakeBmp(lNew)
   local oBmp := iif( lNew, XbpBitMap2():new(), XbpBitmap():new() )
   local oPS := XbpPresSpace():new():create()
   return oBmp:create(oPS)

Function Bmp2Png256(lNew)
   local lOk
   local oBmp := MakeBmp(lNew)

   lOk := oBmp:loadFile('64x64x256.bmp')
   if lNew
      oBmp:saveFile('64x64x256_2.png', XBPBMP_FORMAT_PNG,;
                     Z_BEST_COMPRESSION, TRUE, ;
                     "This is a sample image",;
                     "This is a longer bit of text which also tells us it is a sample image")
   else
      if fexists('64x64x256_2.png')
         ferase('64x64x256_2.png')
      endif

      oBmp:saveFile('64x64x256_2.png', XBPBMP_FORMAT_PNG,100)
   endif


   return lOk

Function Bmp2PngTrueColor()
   local lOk
   local oBmp := MakeBmp()

   lOk := oBmp:loadFile('800x600x16M.bmp')
   oBmp:saveFile('800x600x16M_2.png', XBPBMP_FORMAT_PNG,;
                  NIL, TRUE, ;
                  "This is a sample image",;
                  "This is a longer bit of text which also tells us it is a sample image")

   return lOk

